var _operators;

import { IN, INPATTERN, NIN, NINPATTERN, EXISTS, NEXISTS, CHANGED, EQUALS, GREATERTHAN, GREATERTHANEQUALS, LESSTHAN, LESSTHANEQUALS } from './constants';
import { pickFieldById } from './fields';
import { LocalizationFactory } from '../Standard/Localization/LocalizationFactory';
export var operators = (_operators = {}, _operators[IN] = function (id, values, fields) {
  var field = pickFieldById(fields, id);
  var shouldApply = values.some(function (value) {
    return value === field.value;
  });
  return shouldApply;
}, _operators[NIN] = function (id, values, fields) {
  return !operators.IN(id, values, fields);
}, _operators[INPATTERN] = function (id, values, fields) {
  var field = pickFieldById(fields, id);
  var shouldApply = values.some(function (value) {
    var _field$value;

    return (_field$value = field.value) == null ? void 0 : _field$value.match(value);
  });
  return shouldApply;
}, _operators[NINPATTERN] = function (id, values, fields) {
  return !operators.INPATTERN(id, values, fields);
}, _operators[EXISTS] = function (id, fields) {
  var field = pickFieldById(fields, id);
  return Boolean(field && field.value);
}, _operators[NEXISTS] = function (id, fields) {
  return !operators.EXISTS(id, fields);
}, _operators[CHANGED] = function (id, changeField) {
  return id === changeField;
}, _operators[EQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;
  var equalTo = values[0];

  if (typeof equalTo === 'number') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = equalTo === value;
  return shouldApply;
}, _operators[GREATERTHAN] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value > values[0];
  return shouldApply;
}, _operators[GREATERTHANEQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value >= values[0];
  return shouldApply;
}, _operators[LESSTHAN] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value < values[0];
  return shouldApply;
}, _operators[LESSTHANEQUALS] = function (id, values, fields, locale) {
  var field = pickFieldById(fields, id);
  var value = field.value;

  if (typeof field.value === 'string') {
    var localization = LocalizationFactory({
      value: value,
      locale: locale
    });
    value = localization.fromStringToLocaleFloat();
  }

  var shouldApply = value <= values[0];
  return shouldApply;
}, _operators);